
<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <!--        <el-button type="primary"-->
        <!--                   size="small"-->
        <!--                   plain-->
        <!--                   @click="handleDelete">确认发货-->
        <!--        </el-button>-->
      </template>
      <template slot-scope="scope" slot="menu">
        <el-button type="text"
                   size="small"
                   @click="goodsListView(scope.row.grouponId)">查看详情</el-button>
      </template>
    </avue-crud>
    <!--  商品列表dialog  -->
    <el-dialog title="详情列表"
               append-to-body
               :visible.sync="goodsBox"
               :before-close="handleClose"
               width="50%"
               heigh="30%">
      <avue-crud :option="appointGoodsOption"
                 :table-loading="goodsLoading"
                 :data="appointGoodsData"
                 :page.sync="goodsPage"
                 ref="grouponCrud"
                 @size-change="sizeAppointChange"
                 @on-load="goodsOnLoad">
        <template slot="menuLeft">
          <el-button type="primary"
                     size="small"
                     plain
                     @click="downLoadAppoint">下载详情
          </el-button>
        </template>
        <template slot-scope="scope" slot="menu">

        </template>
      </avue-crud>
    </el-dialog>
  </basic-container>

</template>

<script>
import {getList, getDetail, add, update, shipments, shipmentsAll, appointStoreList} from "@/api/distribution/appoint";
import {mapGetters} from "vuex";
import {appointGoodsOption} from "../../option/mall/appointGoodsOption"
import {getToken} from '@/util/auth';

export default {
  data() {
    return {
      form: {},
      query: {},
      loading: true,
      goodsBox: false,
      goodsLoading: false,
      page: {
        pageSize: 10,
        currentPage: 1,
        total: 0
      },
      grouponId: 0,
      appointGoodsData: [],
      goodsPage: {
        pageSize: 10,
        currentPage: 1,
        total: 0
      },
      selectionList: [],
      appointGoodsOption,
      option: {
        height:'auto',
        calcHeight: 30,
        addBtn: false,
        tip: false,
        searchShow: true,
        searchMenuSpan: 6,
        border: true,
        index: true,
        editBtn: false,
        viewBtn: false,
        delBtn: false,
        selection: false,
        searchSpan: 5,
        dialogClickModal: false,
        column: [
          {
            label: "团购标题",
            labelWidth: 130,
            prop: "grouponName",
            rules: [{
              required: true,
              message: "请输入团购标题",
              trigger: "blur"
            }]
          },
          {
            label: "团购开始时间",
            labelWidth: 130,
            prop: "grouponStartTime",

          },
          {
            label: "履约单状态",
            labelWidth: 130,
            prop: "appointState",
            searchLabelWidth: 130,
            type: "select",
            dicUrl: "/api/blade-system/dict-biz/dictionary?code=appoint_state",
            props: {
              label: "dictValue",
              value: "dictKey"
            },
            dataType: "number",
            search: true,
            hide: false,
            display: true,
            rules: [{
              required: true,
              message: "选择状态",
              trigger: "blur"
            }]
          },
        ]
      },
      data: []
    };
  },
  computed: {
    ...mapGetters(["permission"]),
    permissionList() {
      return {
        // addBtn: this.vaildData(this.permission.appoint_add, false),
        // viewBtn: this.vaildData(this.permission.appoint_view, false),
        // delBtn: this.vaildData(this.permission.appoint_delete, false),
        // editBtn: this.vaildData(this.permission.appoint_edit, false)
      };
    },
    ids() {
      let ids = [];
      this.selectionList.forEach(ele => {
        ids.push(ele.id);
      });
      return ids.join(",");
    }
  },
  methods: {
    rowSave(row, done, loading) {
      add(row).then(() => {
        this.onLoad(this.page);
        this.$message({
          type: "success",
          message: "操作成功!"
        });
        done();
      }, error => {
        loading();
        window.console.log(error);
      });
    },

    downLoadAppoint(){
      window.open(`/api/distribution/appoint/exportAllAppointGoods?${this.website.tokenHeader}=${getToken()}&grouponId=${this.grouponId}`);
    },
    rowUpdate(row, index, done, loading) {
      update(row).then(() => {
        this.onLoad(this.page);
        this.$message({
          type: "success",
          message: "操作成功!"
        });
        done();
      }, error => {
        loading();
        console.log(error);
      });
    },

    rowDel(row) {
      this.$confirm("确定将选择数据删除?", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
    },
    shipments(id){
      this.$confirm("确定将改履约单进行发货么?", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      })
          .then(() => {
            return shipments(id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.goodsOnLoad(this.goodsPage)
            this.$refs.grouponCrud.toggleSelection();
          });

    },
    shipmnetsALl(grouponId){
      this.$confirm("确定将这个团的所有履约单进行发货么?", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      })
          .then(() => {
            return shipmentsAll(grouponId);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
    },
    beforeOpen(done, type) {
      if (["edit", "view"].includes(type)) {
        getDetail(this.form.id).then(res => {
          this.form = res.data.data;
        });
      }
      done();
    },
    searchReset() {
      this.query = {};
      this.onLoad(this.page);
    },
    searchChange(params, done) {
      this.query = params;
      this.page.currentPage = 1;
      this.onLoad(this.page, params);
      done();
    },
    selectionChange(list) {
      this.selectionList = list;
    },
    selectionClear() {
      this.selectionList = [];
      this.$refs.crud.toggleSelection();
    },
    currentChange(currentPage){
      this.page.currentPage = currentPage;
    },
    sizeChange(pageSize){
      this.page.pageSize = pageSize;
    },
    sizeAppointChange(pageSize){
      this.goodsPage.pageSize = pageSize;
    },
    refreshChange() {
      this.onLoad(this.page, this.query);
    },
    onLoad(page, params = {}) {
      this.loading = true;
      getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
        const data = res.data.data;
        this.page.total = data.total;
        this.data = data.records;
        this.loading = false;
        this.selectionClear();
      });
    },

    goodsListView(grouponId) {
      this.grouponId = grouponId;
      this.goodsPage = {
        pageSize: 10,
        currentPage: 1,
        total: 0
      }
      this.goodsOnLoad(this.goodsPage)
      this.goodsBox = true;
    },
    handleClose() {
      this.goodsBox = false;
    },
    goodsOnLoad(page){
      this.goodsLoading = true;
      appointStoreList(page.currentPage, page.pageSize, this.grouponId).then(res => {
        const data = res.data.data;
        this.goodsPage.total = data.total;
        this.appointGoodsData = data.records;
        this.goodsLoading = false;
        this.selectionClear();
      });
    }
  }
};
</script>

<style>
</style>
